Index: lemon/concepts/graph_components.h
===================================================================
--- lemon/concepts/graph_components.h	(revision 1270)
+++ lemon/concepts/graph_components.h	(revision 833)
@@ -1929,64 +1373,4 @@
 
         _Graph& graph;
-        Constraints() {}
-      };
-    };
-
-    /// \brief Skeleton class for extendable undirected bipartite graphs.
-    ///
-    /// This class describes the interface of extendable undirected
-    /// bipartite graphs. It extends \ref BaseGraphComponent with
-    /// functions for adding nodes and edges to the graph. This
-    /// concept requires \ref AlterableBpGraphComponent.
-    template <typename BAS = BaseBpGraphComponent>
-    class ExtendableBpGraphComponent : public BAS {
-    public:
-
-      typedef BAS Base;
-      typedef typename Base::Node Node;
-      typedef typename Base::RedNode RedNode;
-      typedef typename Base::BlueNode BlueNode;
-      typedef typename Base::Edge Edge;
-
-      /// \brief Add a new red node to the digraph.
-      ///
-      /// This function adds a red new node to the digraph.
-      RedNode addRedNode() {
-        return INVALID;
-      }
-
-      /// \brief Add a new blue node to the digraph.
-      ///
-      /// This function adds a blue new node to the digraph.
-      BlueNode addBlueNode() {
-        return INVALID;
-      }
-
-      /// \brief Add a new edge connecting the given two nodes.
-      ///
-      /// This function adds a new edge connecting the given two nodes
-      /// of the graph. The first node has to be a red node, and the
-      /// second one a blue node.
-      Edge addEdge(const RedNode&, const BlueNode&) {
-        return INVALID;
-      }
-      Edge addEdge(const BlueNode&, const RedNode&) {
-        return INVALID;
-      }
-
-      template <typename _BpGraph>
-      struct Constraints {
-        void constraints() {
-          checkConcept<Base, _BpGraph>();
-          typename _BpGraph::RedNode red_node;
-          typename _BpGraph::BlueNode blue_node;
-          red_node = bpgraph.addRedNode();
-          blue_node = bpgraph.addBlueNode();
-          typename _BpGraph::Edge edge;
-          edge = bpgraph.addEdge(red_node, blue_node);
-          edge = bpgraph.addEdge(blue_node, red_node);
-        }
-
-        _BpGraph& bpgraph;
       };
     };
@@ -1995,5 +1379,5 @@
     ///
     /// This class describes the interface of erasable directed graphs.
-    /// It extends \ref BaseDigraphComponent with functions for removing
+    /// It extends \ref BaseDigraphComponent with functions for removing 
     /// nodes and arcs from the digraph.
     /// This concept requires \ref AlterableDigraphComponent.
@@ -2008,5 +1392,5 @@
       /// \brief Erase a node from the digraph.
       ///
-      /// This function erases the given node from the digraph and all arcs
+      /// This function erases the given node from the digraph and all arcs 
       /// connected to the node.
       void erase(const Node&) {}
@@ -2028,5 +1412,4 @@
 
         _Digraph& digraph;
-        Constraints() {}
       };
     };
@@ -2035,5 +1418,5 @@
     ///
     /// This class describes the interface of erasable undirected graphs.
-    /// It extends \ref BaseGraphComponent with functions for removing
+    /// It extends \ref BaseGraphComponent with functions for removing 
     /// nodes and edges from the graph.
     /// This concept requires \ref AlterableGraphComponent.
@@ -2068,16 +1451,6 @@
 
         _Graph& graph;
-        Constraints() {}
-      };
-    };
-
-    /// \brief Skeleton class for erasable undirected graphs.
-    ///
-    /// This class describes the interface of erasable undirected
-    /// bipartite graphs. It extends \ref BaseBpGraphComponent with
-    /// functions for removing nodes and edges from the graph. This
-    /// concept requires \ref AlterableBpGraphComponent.
-    template <typename BAS = BaseBpGraphComponent>
-    class ErasableBpGraphComponent : public ErasableGraphComponent<BAS> {};
+      };
+    };
 
     /// \brief Skeleton class for clearable directed graphs.
@@ -2106,5 +1479,4 @@
 
         _Digraph& digraph;
-        Constraints() {}
       };
     };
@@ -2117,14 +1489,24 @@
     /// This concept requires \ref AlterableGraphComponent.
     template <typename BAS = BaseGraphComponent>
-    class ClearableGraphComponent : public ClearableDigraphComponent<BAS> {};
-
-    /// \brief Skeleton class for clearable undirected biparite graphs.
-    ///
-    /// This class describes the interface of clearable undirected
-    /// bipartite graphs. It extends \ref BaseBpGraphComponent with a
-    /// function for clearing the graph.  This concept requires \ref
-    /// AlterableBpGraphComponent.
-    template <typename BAS = BaseBpGraphComponent>
-    class ClearableBpGraphComponent : public ClearableGraphComponent<BAS> {};
+    class ClearableGraphComponent : public ClearableDigraphComponent<BAS> {
+    public:
+
+      typedef BAS Base;
+
+      /// \brief Erase all nodes and edges from the graph.
+      ///
+      /// This function erases all nodes and edges from the graph.
+      void clear() {}
+
+      template <typename _Graph>
+      struct Constraints {
+        void constraints() {
+          checkConcept<Base, _Graph>();
+          graph.clear();
+        }
+
+        _Graph& graph;
+      };
+    };
 
   }
Index: lemon/concepts/heap.h
===================================================================
--- lemon/concepts/heap.h	(revision 1270)
+++ lemon/concepts/heap.h	(revision 883)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -93,5 +93,5 @@
 #else
       explicit Heap(ItemIntMap&) {}
-#endif
+#endif      
 
       /// \brief Constructor.
@@ -107,5 +107,5 @@
 #else
       explicit Heap(ItemIntMap&, const CMP&) {}
-#endif
+#endif      
 
       /// \brief The number of items stored in the heap.
@@ -139,5 +139,5 @@
 #else
       void push(const Item&, const Prio&) {}
-#endif
+#endif      
 
       /// \brief Return the item having minimum priority.
@@ -169,5 +169,5 @@
 #else
       void erase(const Item&) {}
-#endif
+#endif      
 
       /// \brief The priority of the given item.
@@ -180,5 +180,5 @@
 #else
       Prio operator[](const Item&) const { return Prio(); }
-#endif
+#endif      
 
       /// \brief Set the priority of an item or insert it, if it is
@@ -195,5 +195,5 @@
 #else
       void set(const Item&, const Prio&) {}
-#endif
+#endif      
 
       /// \brief Decrease the priority of an item to the given value.
@@ -207,5 +207,5 @@
 #else
       void decrease(const Item&, const Prio&) {}
-#endif
+#endif      
 
       /// \brief Increase the priority of an item to the given value.
@@ -219,5 +219,5 @@
 #else
       void increase(const Item&, const Prio&) {}
-#endif
+#endif      
 
       /// \brief Return the state of an item.
@@ -233,5 +233,5 @@
 #else
       State state(const Item&) const { return PRE_HEAP; }
-#endif
+#endif      
 
       /// \brief Set the state of an item in the heap.
@@ -246,5 +246,5 @@
 #else
       void state(const Item&, State) {}
-#endif
+#endif      
 
 
@@ -261,6 +261,6 @@
           item=Item();
           prio=Prio();
-          ::lemon::ignore_unused_variable_warning(item);
-          ::lemon::ignore_unused_variable_warning(prio);
+          ignore_unused_variable_warning(item);
+          ignore_unused_variable_warning(prio);
 
           OwnItem own_item;
@@ -269,17 +269,17 @@
           own_item=Item();
           own_prio=Prio();
-          ::lemon::ignore_unused_variable_warning(own_item);
-          ::lemon::ignore_unused_variable_warning(own_prio);
-          ::lemon::ignore_unused_variable_warning(own_state);
+          ignore_unused_variable_warning(own_item);
+          ignore_unused_variable_warning(own_prio);
+          ignore_unused_variable_warning(own_state);
 
           _Heap heap1(map);
           _Heap heap2 = heap1;
-          ::lemon::ignore_unused_variable_warning(heap1);
-          ::lemon::ignore_unused_variable_warning(heap2);
+          ignore_unused_variable_warning(heap1);
+          ignore_unused_variable_warning(heap2);
 
           int s = heap.size();
-          ::lemon::ignore_unused_variable_warning(s);
+          ignore_unused_variable_warning(s);
           bool e = heap.empty();
-          ::lemon::ignore_unused_variable_warning(e);
+          ignore_unused_variable_warning(e);
 
           prio = heap.prio();
@@ -315,5 +315,4 @@
         _Heap& heap;
         ItemIntMap& map;
-        Constraints() {}
       };
     };
Index: lemon/concepts/maps.h
===================================================================
--- lemon/concepts/maps.h	(revision 1270)
+++ lemon/concepts/maps.h	(revision 765)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -50,5 +50,5 @@
       /// Returns the value associated with the given key.
       Value operator[](const Key &) const {
-        return *(static_cast<Value *>(0)+1);
+        return *static_cast<Value *>(0);
       }
 
@@ -61,13 +61,12 @@
           own_val = m[own_key];
 
-          ::lemon::ignore_unused_variable_warning(key);
-          ::lemon::ignore_unused_variable_warning(val);
-          ::lemon::ignore_unused_variable_warning(own_key);
-          ::lemon::ignore_unused_variable_warning(own_val);
+          ignore_unused_variable_warning(key);
+          ignore_unused_variable_warning(val);
+          ignore_unused_variable_warning(own_key);
+          ignore_unused_variable_warning(own_val);
         }
         const Key& key;
         const typename _ReadMap::Key& own_key;
         const _ReadMap& m;
-        Constraints() {}
       };
 
@@ -101,8 +100,8 @@
           m.set(own_key, own_val);
 
-          ::lemon::ignore_unused_variable_warning(key);
-          ::lemon::ignore_unused_variable_warning(val);
-          ::lemon::ignore_unused_variable_warning(own_key);
-          ::lemon::ignore_unused_variable_warning(own_val);
+          ignore_unused_variable_warning(key);
+          ignore_unused_variable_warning(val);
+          ignore_unused_variable_warning(own_key);
+          ignore_unused_variable_warning(own_val);
         }
         const Key& key;
@@ -111,5 +110,4 @@
         const typename _WriteMap::Value& own_val;
         _WriteMap& m;
-        Constraints() {}
       };
     };
@@ -132,6 +130,5 @@
       /// Returns the value associated with the given key.
       Value operator[](const Key &) const {
-        Value *r = 0;
-        return *r;
+        return *static_cast<Value *>(0);
       }
 
@@ -173,12 +170,10 @@
       /// Returns a reference to the value associated with the given key.
       Reference operator[](const Key &) {
-        Value *r = 0;
-        return *r;
+        return *static_cast<Value *>(0);
       }
 
       /// Returns a const reference to the value associated with the given key.
       ConstReference operator[](const Key &) const {
-        Value *r = 0;
-        return *r;
+        return *static_cast<Value *>(0);
       }
 
@@ -211,5 +206,4 @@
         typename _ReferenceMap::ConstReference own_cref;
         _ReferenceMap& m;
-        Constraints() {}
       };
     };
Index: lemon/concepts/path.h
===================================================================
--- lemon/concepts/path.h	(revision 1336)
+++ lemon/concepts/path.h	(revision 832)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -27,5 +27,4 @@
 #include <lemon/core.h>
 #include <lemon/concept_check.h>
-#include <lemon/bits/stl_iterators.h>
 
 namespace lemon {
@@ -77,5 +76,5 @@
       template <typename CPath>
       Path& operator=(const CPath& cpath) {
-        ::lemon::ignore_unused_variable_warning(cpath);
+        ignore_unused_variable_warning(cpath);
         return *this;
       }
@@ -117,21 +116,4 @@
       };
 
-      /// \brief Gets the collection of the arcs of the path.
-      ///
-      /// This function can be used for iterating on the
-      /// arcs of the path. It returns a wrapped
-      /// ArcIt, which looks like an STL container
-      /// (by having begin() and end()) which you can use in range-based
-      /// for loops, STL algorithms, etc.
-      /// For example you can write:
-      ///\code
-      /// for(auto a: p.arcs())
-      ///   doSomething(a);
-      ///\endcode
-      LemonRangeWrapper1<ArcIt, Path> arcs() const {
-        return LemonRangeWrapper1<ArcIt, Path>(*this);
-      }
-
-
       template <typename _Path>
       struct Constraints {
@@ -154,10 +136,10 @@
           e = (i < ii);
 
-          ::lemon::ignore_unused_variable_warning(l);
-          ::lemon::ignore_unused_variable_warning(pp);
-          ::lemon::ignore_unused_variable_warning(e);
-          ::lemon::ignore_unused_variable_warning(id);
-          ::lemon::ignore_unused_variable_warning(ii);
-          ::lemon::ignore_unused_variable_warning(ed);
+          ignore_unused_variable_warning(l);
+          ignore_unused_variable_warning(pp);
+          ignore_unused_variable_warning(e);
+          ignore_unused_variable_warning(id);
+          ignore_unused_variable_warning(ii);
+          ignore_unused_variable_warning(ed);
         }
       };
@@ -181,11 +163,10 @@
           e = (i != INVALID);
 
-          ::lemon::ignore_unused_variable_warning(l);
-          ::lemon::ignore_unused_variable_warning(e);
-          ::lemon::ignore_unused_variable_warning(id);
-          ::lemon::ignore_unused_variable_warning(ed);
+          ignore_unused_variable_warning(l);
+          ignore_unused_variable_warning(e);
+          ignore_unused_variable_warning(id);
+          ignore_unused_variable_warning(ed);
         }
         _Path& p;
-        PathDumperConstraints() {}
       };
 
@@ -207,11 +188,10 @@
           e = (i != INVALID);
 
-          ::lemon::ignore_unused_variable_warning(l);
-          ::lemon::ignore_unused_variable_warning(e);
-          ::lemon::ignore_unused_variable_warning(id);
-          ::lemon::ignore_unused_variable_warning(ed);
+          ignore_unused_variable_warning(l);
+          ignore_unused_variable_warning(e);
+          ignore_unused_variable_warning(id);
+          ignore_unused_variable_warning(ed);
         }
         _Path& p;
-        PathDumperConstraints() {}
       };
 
@@ -282,21 +262,4 @@
 
       };
-
-      /// \brief Gets the collection of the arcs of the path.
-      ///
-      /// This function can be used for iterating on the
-      /// arcs of the path. It returns a wrapped
-      /// ArcIt, which looks like an STL container
-      /// (by having begin() and end()) which you can use in range-based
-      /// for loops, STL algorithms, etc.
-      /// For example you can write:
-      ///\code
-      /// for(auto a: p.arcs())
-      ///   doSomething(a);
-      ///\endcode
-      LemonRangeWrapper1<ArcIt, PathDumper> arcs() const {
-        return LemonRangeWrapper1<ArcIt, PathDumper>(*this);
-      }
-
 
       /// \brief LEMON style iterator for enumerating the arcs of a path
@@ -329,22 +292,4 @@
       };
 
-      /// \brief Gets the collection of the arcs of the path
-      /// in reverse direction.
-      ///
-      /// This function can be used for iterating on the
-      /// arcs of the path in reverse direction. It returns a wrapped
-      /// RevArcIt, which looks like an STL container
-      /// (by having begin() and end()) which you can use in range-based
-      /// for loops, STL algorithms, etc.
-      /// For example you can write:
-      ///\code
-      /// for(auto a: p.revArcs())
-      ///   doSomething(a);
-      ///\endcode
-      LemonRangeWrapper1<RevArcIt, PathDumper> revArcs() const {
-        return LemonRangeWrapper1<RevArcIt, PathDumper>(*this);
-      }
-
-
       template <typename _Path>
       struct Constraints {
Index: lemon/config.h.cmake
===================================================================
--- lemon/config.h.cmake	(revision 725)
+++ lemon/config.h.cmake	(revision 725)
@@ -0,0 +1,8 @@
+#define LEMON_VERSION "@PROJECT_VERSION@"
+#cmakedefine LEMON_HAVE_LONG_LONG 1
+#cmakedefine LEMON_HAVE_LP 1
+#cmakedefine LEMON_HAVE_MIP 1
+#cmakedefine LEMON_HAVE_GLPK 1
+#cmakedefine LEMON_HAVE_CPLEX 1
+#cmakedefine LEMON_HAVE_CLP 1
+#cmakedefine LEMON_HAVE_CBC 1
Index: lemon/config.h.in
===================================================================
--- lemon/config.h.in	(revision 1343)
+++ lemon/config.h.in	(revision 725)
@@ -1,31 +1,26 @@
-#ifndef LEMON_CONFIG_H
-#define LEMON_CONFIG_H
+/* The version string */
+#undef LEMON_VERSION
 
-#define LEMON_VERSION "@PROJECT_VERSION@"
-#cmakedefine LEMON_HAVE_LONG_LONG 1
+/* Define to 1 if you have long long */
+#undef LEMON_HAVE_LONG_LONG
 
-#cmakedefine LEMON_CXX11 1
+/* Define to 1 if you have any LP solver. */
+#undef LEMON_HAVE_LP
 
-#cmakedefine LEMON_WIN32 1
+/* Define to 1 if you have any MIP solver. */
+#undef LEMON_HAVE_MIP
 
-#cmakedefine LEMON_HAVE_LP 1
-#cmakedefine LEMON_HAVE_MIP 1
-#cmakedefine LEMON_HAVE_GLPK 1
-#cmakedefine LEMON_HAVE_CPLEX 1
-#cmakedefine LEMON_HAVE_SOPLEX 1
-#cmakedefine LEMON_HAVE_CLP 1
-#cmakedefine LEMON_HAVE_CBC 1
+/* Define to 1 if you have CPLEX. */
+#undef LEMON_HAVE_CPLEX
 
-#define LEMON_CPLEX_ 1
-#define LEMON_CLP_ 2
-#define LEMON_GLPK_ 3
-#define LEMON_SOPLEX_ 4
-#define LEMON_CBC_ 5
+/* Define to 1 if you have GLPK. */
+#undef LEMON_HAVE_GLPK
 
-#cmakedefine LEMON_DEFAULT_LP LEMON_@LEMON_DEFAULT_LP@_
-#cmakedefine LEMON_DEFAULT_MIP LEMON_@LEMON_DEFAULT_MIP@_
+/* Define to 1 if you have SOPLEX */
+#undef LEMON_HAVE_SOPLEX
 
-#cmakedefine LEMON_USE_PTHREAD 1
-#cmakedefine LEMON_USE_WIN32_THREADS 1
+/* Define to 1 if you have CLP */
+#undef LEMON_HAVE_CLP
 
-#endif
+/* Define to 1 if you have CBC */
+#undef LEMON_HAVE_CBC
Index: lemon/connectivity.h
===================================================================
--- lemon/connectivity.h	(revision 1270)
+++ lemon/connectivity.h	(revision 695)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2013
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -259,5 +259,5 @@
   /// \return \c true if the digraph is strongly connected.
   /// \note By definition, the empty digraph is strongly connected.
-  ///
+  /// 
   /// \see countStronglyConnectedComponents(), stronglyConnectedComponents()
   /// \see connected()
@@ -311,5 +311,5 @@
   /// \ingroup graph_properties
   ///
-  /// \brief Count the number of strongly connected components of a
+  /// \brief Count the number of strongly connected components of a 
   /// directed graph
   ///
@@ -745,36 +745,13 @@
   /// \brief Check whether an undirected graph is bi-node-connected.
   ///
-  /// This function checks whether the given undirected graph is
-  /// bi-node-connected, i.e. a connected graph without articulation
-  /// node.
+  /// This function checks whether the given undirected graph is 
+  /// bi-node-connected, i.e. any two edges are on same circle.
   ///
   /// \return \c true if the graph bi-node-connected.
-  ///
-  /// \note By definition,
-  /// \li a graph consisting of zero or one node is bi-node-connected,
-  /// \li a graph consisting of two isolated nodes
-  /// is \e not bi-node-connected and
-  /// \li a graph consisting of two nodes connected by an edge
-  /// is bi-node-connected.
+  /// \note By definition, the empty graph is bi-node-connected.
   ///
   /// \see countBiNodeConnectedComponents(), biNodeConnectedComponents()
   template <typename Graph>
   bool biNodeConnected(const Graph& graph) {
-    bool hasNonIsolated = false, hasIsolated = false;
-    for (typename Graph::NodeIt n(graph); n != INVALID; ++n) {
-      if (typename Graph::OutArcIt(graph, n) == INVALID) {
-        if (hasIsolated || hasNonIsolated) {
-          return false;
-        } else {
-          hasIsolated = true;
-        }
-      } else {
-        if (hasIsolated) {
-          return false;
-        } else {
-          hasNonIsolated = true;
-        }
-      }
-    }
     return countBiNodeConnectedComponents(graph) <= 1;
   }
@@ -782,5 +759,5 @@
   /// \ingroup graph_properties
   ///
-  /// \brief Count the number of bi-node-connected components of an
+  /// \brief Count the number of bi-node-connected components of an 
   /// undirected graph.
   ///
@@ -836,5 +813,5 @@
   /// \retval compMap A writable edge map. The values will be set from 0
   /// to the number of the bi-node-connected components minus one. Each
-  /// value of the map will be set exactly once, and the values of a
+  /// value of the map will be set exactly once, and the values of a 
   /// certain component will be set continuously.
   /// \return The number of bi-node-connected components.
@@ -882,5 +859,5 @@
   ///
   /// \param graph The undirected graph.
-  /// \retval cutMap A writable node map. The values will be set to
+  /// \retval cutMap A writable node map. The values will be set to 
   /// \c true for the nodes that separate two or more components
   /// (exactly once for each cut node), and will not be changed for
@@ -1109,5 +1086,5 @@
   /// \brief Check whether an undirected graph is bi-edge-connected.
   ///
-  /// This function checks whether the given undirected graph is
+  /// This function checks whether the given undirected graph is 
   /// bi-edge-connected, i.e. any two nodes are connected with at least
   /// two edge-disjoint paths.
@@ -1216,5 +1193,5 @@
   ///
   /// This function finds the bi-edge-connected cut edges in the given
-  /// undirected graph.
+  /// undirected graph. 
   ///
   /// The bi-edge-connected components are the classes of an equivalence
@@ -1373,5 +1350,5 @@
   /// \param digraph The digraph.
   /// \retval order A readable and writable node map. The values will be
-  /// set from 0 to the number of the nodes in the digraph minus one.
+  /// set from 0 to the number of the nodes in the digraph minus one. 
   /// Each value of the map will be set exactly once, and the values will
   /// be set descending order.
